diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
index a2f3d8542..352940ae3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/ImprovedNoise.java
@@ -4,30 +4,134 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class ImprovedNoise
-    extends BaseImprovedNoise {
+// Derived from Ken Perlin's Improved Noise reference implementation: https://cs.nyu.edu/~perlin/noise/
+public class ImprovedNoise {
     private final @NotNull LegacyNoiseType legacyNoiseType;
 
-    public ImprovedNoise(final @NotNull Random random, final @NotNull LegacyNoiseType legacyNoiseType) {
-        super(random);
+    private final int @NotNull [] p;
+
+    public final double xo;
+    public final double yo;
+    public final double zo;
 
+    public ImprovedNoise(final @NotNull Random random) {
+        this(random, LegacyNoiseType.DEFAULT);
+    }
+
+    public ImprovedNoise(final @NotNull Random random, final @NotNull LegacyNoiseType legacyNoiseType) {
         this.legacyNoiseType = legacyNoiseType;
+
+        this.p = new int[512];
+        this.xo = random.nextDouble() * 256;
+        this.yo = random.nextDouble() * 256;
+        this.zo = random.nextDouble() * 256;
+
+        // Assign initial values for each permutation
+        for (int i = 0; i < 256; i++) {
+            this.p[i] = i;
+        }
+
+        // Shuffle values
+        for (int i = 0; i < 256; i++) {
+            final int newI = random.nextInt(256 - i) + i;
+            final int temp = this.p[i];
+            this.p[i] = this.p[newI];
+            this.p[newI] = temp;
+            this.p[i + 256] = this.p[i];
+        }
     }
 
-    public ImprovedNoise(final @NotNull Random random) {
-        this(random, LegacyNoiseType.NONE);
+    public double getValue(final double x, final double z) {
+        return this.getValue(x, z, 0);
+    }
+
+    public double getValue(double x, double y, double z) {
+        // Find unit cube that contains point
+        final int X = (int) Math.floor(x) & 255;
+        final int Y = (int) Math.floor(y) & 255;
+        final int Z = (int) Math.floor(z) & 255;
+
+        // Find relative XYZ of point in cube
+        x -= Math.floor(x);
+        y -= Math.floor(y);
+        z -= Math.floor(z);
+
+        // Compute fade curves for each of X, Y, and Z
+        final double u = this.fade(x);
+        final double v = this.fade(y);
+        final double w = this.fade(z);
+
+        // Hash coordinates of the 8 cube corners
+        final int A  = this.p[X    ] + Y;
+        final int AA = this.p[A    ] + Z;
+        final int AB = this.p[A + 1] + Z;
+        final int B =  this.p[X + 1] + Y;
+        final int BA = this.p[B    ] + Z;
+        final int BB = this.p[B + 1] + Z;
+
+        // Add blended results from 8 corners of the cube
+        return this.lerp(
+            w,
+            this.lerp(
+                v,
+                this.lerp(
+                    u,
+                    this.grad(this.p[AA], x, y, z),
+                    this.grad(this.p[BA], x - 1, y, z)
+                ),
+                this.lerp(
+                    u,
+                    this.grad(this.p[AB], x, y - 1, z),
+                    this.grad(this.p[BB], x - 1, y - 1, z)
+                )
+            ),
+            this.lerp(
+                v,
+                this.lerp(
+                    u,
+                    this.grad(this.p[AA + 1], x, y, z - 1),
+                    this.grad(this.p[BA + 1], x - 1, y, z - 1)),
+                this.lerp(
+                    u,
+                    this.grad(this.p[AB + 1], x, y - 1, z - 1),
+                    this.grad(this.p[BB + 1], x - 1, y - 1, z - 1)
+                )
+            )
+        );
+    }
+
+    protected double grad2(final int hash, final double x, final double y) {
+        final int h = hash & 15;
+        final double u = (double) (1 - ((h & 8) >> 3)) * x;
+        final double v = h < 4 ? 0.0D : h == 12 || h == 14 ? x : y;
+
+        return ((h & 1) != 0 ? -u : u) + ((h & 2) != 0 ? -v : v);
+    }
+
+    protected double fade(final double t) {
+        return t * t * t * (t * (t * 6 - 15) + 10);
+    }
+
+    protected double lerp(final double t, final double a, final double b) {
+        return a + t * (b - a);
+    }
+
+    protected double grad(final int hash, final double x, final double y, final double z) {
+        // Converts low 4 bits of hash code into 12 gradient directions.
+        final int h = hash & 15;
+        final double u = h < 8 ? x : y;
+        final double v = h < 4 ? y : h == 12 || h == 14 ? x : z;
+
+        return ((h & 1) == 0 ? u : -u) + ((h & 2) == 0 ? v : -v);
     }
 
-    @Override
     public void add(
         final double @NotNull [] out,
         final double x, final double y, final double z,
         final int xSize, final int ySize, final int zSize,
         final double xScale, final double yScale, final double zScale,
-        final double valueScale
+        final double amplitude
     ) {
-        final double scale = 1.0 / valueScale;
-
         if (ySize == 1 && this.legacyNoiseType.handleEdgeCaseY) {
             int i = 0;
             for (int xi = 0; xi < xSize; xi++) {
@@ -75,7 +179,7 @@ public class ImprovedNoise
                         )
                     );
 
-                    out[i++] += value * scale;
+                    out[i++] += value * amplitude;
                 }
             }
         } else if (zSize == 1 && this.legacyNoiseType.handleEdgeCaseZ) {
@@ -125,7 +229,7 @@ public class ImprovedNoise
                         )
                     );
 
-                    out[i++] += value * scale;
+                    out[i++] += value * amplitude;
                 }
             }
         } else {
@@ -211,7 +315,7 @@ public class ImprovedNoise
                         final double lerpedXYNegZ = this.lerp(v, lerpedXNegZ, lerpedXNegYNegZ);
                         final double lerpedXYZ = this.lerp(w, lerpedXY, lerpedXYNegZ);
 
-                        out[i++] += lerpedXYZ * scale;
+                        out[i++] += lerpedXYZ * amplitude;
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java b/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java
index 1d8b330f8..bea0c9c24 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/LegacyNoiseType.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.world.noise;
 
 public enum LegacyNoiseType {
-    NONE(true, true),
+    DEFAULT(true, true),
     ALPHA(false, false),
     BETA(true, false);
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/Noise.java b/game/core/src/main/java/net/minecraft/core/world/noise/Noise.java
new file mode 100644
index 000000000..48e731b87
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/Noise.java
@@ -0,0 +1,20 @@
+package net.minecraft.core.world.noise;
+
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public interface Noise {
+    double getValue(final double x, final double y);
+    double getValue(final double x, final double y, final double z);
+
+    double @NotNull [] getRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final double xScale, final double zScale
+    );
+    double @NotNull [] getRegion(
+        final double @Nullable [] out,
+        final double x, final double y, final double z,
+        final double xScale, final double yScale, final double zScale
+    );
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java
index daeb826c7..ac9077f77 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinNoise.java
@@ -1,30 +1,136 @@
 package net.minecraft.core.world.noise;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Arrays;
 import java.util.Random;
 
-public class PerlinNoise
-        extends BasePerlinNoise<ImprovedNoise>
-{
-    public PerlinNoise(long seed, int levels)
-    {
-        super(seed, levels);
+public class PerlinNoise {
+    private static final double MAX_2D = Math.sqrt(2.0 / 4.0);
+
+    private final @NotNull ImprovedNoise @NotNull [] octaves;
+    private final int numOctaves;
+    final double maxValue;
+
+    public PerlinNoise(final long seed, final int numOctaves) {
+        this(seed, numOctaves, LegacyNoiseType.DEFAULT);
+    }
+
+    public PerlinNoise(final long seed, final int numOctaves, final int preOctaves) {
+        this(seed, numOctaves, preOctaves, LegacyNoiseType.DEFAULT);
     }
 
-    public PerlinNoise(long seed, int levels, int preLevels)
-    {
-        super(seed, levels, preLevels);
+    public PerlinNoise(final long seed, final int numOctaves, final @NotNull LegacyNoiseType legacyNoiseType) {
+        this(seed, numOctaves, 0, legacyNoiseType);
+    }
+
+    public PerlinNoise(final long seed, final int numOctaves, final int preOctaves, final @NotNull LegacyNoiseType legacyNoiseType) {
+        final @NotNull Random random = new Random(seed);
+
+        for (int i = 0; i < preOctaves; i++) {
+            random.nextDouble();
+            random.nextDouble();
+            random.nextDouble();
+
+            for (int j = 0; j < 256; j++) {
+                random.nextInt(256 - j);
+            }
+        }
+        this.numOctaves = numOctaves;
+        this.octaves = new ImprovedNoise[numOctaves];
+        for (int i = 0; i < numOctaves; i++) {
+            this.octaves[i] = new ImprovedNoise(random, legacyNoiseType);
+        }
+
+        double maxValue = 0.0;
+        double levelScale = 1.0;
+        for (int i = 0; i < this.numOctaves; i++) {
+            maxValue += MAX_2D / levelScale;
+            levelScale /= 2.0;
+        }
+
+        this.maxValue = maxValue;
     }
 
-    @Override
-    protected ImprovedNoise[] newOctaves(Random random, int numOctaves)
-    {
-        ImprovedNoise[] levels = new ImprovedNoise[numOctaves];
+    public double getValue(final double x, final double y) {
+        final double lacunarity = 0.5;
+        final double persistence = 2.0;
+
+        double out = 0.0;
+        double frequency = 1.0;
+        double amplitude = 1.0;
+
+        for (int i = 0; i < this.numOctaves; i++) {
+            out += this.octaves[i].getValue(x * frequency, y * frequency) * amplitude;
+            frequency *= lacunarity;
+            amplitude *= persistence;
+        }
+
+        return out;
+    }
+
+    public double getValue(final double x, final double y, final double z) {
+        final double lacunarity = 0.5;
+        final double persistence = 2.0;
+
+        double out = 0.0;
+        double frequency = 1.0;
+        double amplitude = 1.0;
+
+        for (int i = 0; i < this.numOctaves; i++) {
+            out += this.octaves[i].getValue(x * frequency, y * frequency, z * frequency) * amplitude;
+            frequency *= lacunarity;
+            amplitude *= persistence;
+        }
+
+        return out;
+    }
+
+    public double getNormalized(final double x, final double y) {
+        final double value = this.getValue(x, y);
+
+        // Map to +-1.0
+        double workingValue = value / this.maxValue;
+
+        // Map to 0.0-1.0
+        workingValue = 0.5 + (workingValue / 2.0);
+
+        return workingValue;
+    }
+
+    public double @NotNull [] getRegion(
+        final double @Nullable [] densityArray,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double scaleX, final double scaleZ
+    ) {
+        return this.getRegion(densityArray, x, 0, z, xSize, 1, zSize, scaleX, 1.0, scaleZ);
+    }
+
+    public double @NotNull [] getRegion(
+        double @Nullable [] noiseArray,
+        final double x, final double y, final double z,
+        final int xSize, final int ySize, final int zSize,
+        final double xScale, final double yScale, final double zScale
+    ) {
+        if (noiseArray == null) {
+            noiseArray = new double[xSize * ySize * zSize];
+        } else {
+            Arrays.fill(noiseArray, 0.0);
+        }
+
+        final double lacunarity = 0.5;
+        final double persistence = 2.0;
 
-        for (int i = 0; i < numOctaves; i++)
-        {
-            levels[i] = new ImprovedNoise(random);
+        double frequency = 1.0;
+        double amplitude = 1.0;
+        for (int i = 0; i < this.numOctaves; i++) {
+            this.octaves[i].add(noiseArray, x, y, z, xSize, ySize, zSize, xScale * frequency, yScale * frequency, zScale * frequency, amplitude);
+            frequency *= lacunarity;
+            amplitude *= persistence;
         }
 
-        return levels;
+        return noiseArray;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java
index 92ac51555..0fd929e45 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/PerlinSimplexNoise.java
@@ -1,70 +1,49 @@
 package net.minecraft.core.world.noise;
 
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
 import java.util.Arrays;
 import java.util.Random;
 
-public class PerlinSimplexNoise extends SurfaceNoise
-{
-    private final SimplexNoise[] octaves;
+public class PerlinSimplexNoise {
+    private final @NotNull SimplexNoise @NotNull [] octaves;
     private final int numOctaves;
 
-    public PerlinSimplexNoise(Random random, int numOctaves)
-    {
+    public PerlinSimplexNoise(final @NotNull Random random, final int numOctaves) {
         this.numOctaves = numOctaves;
-        octaves = new SimplexNoise[numOctaves];
-        for(int i = 0; i < numOctaves; i++)
-        {
-            octaves[i] = new SimplexNoise(random);
+        this.octaves = new SimplexNoise[numOctaves];
+        for (int i = 0; i < numOctaves; i++) {
+            this.octaves[i] = new SimplexNoise(random);
         }
     }
 
-    public double getMaximumValue()
-    {
-        return getMaximumValue(0.5);
+    public double @NotNull [] getRegion(
+        final double @Nullable [] out,
+        final double x, final double z,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double lacunarity
+    ) {
+        return this.getRegion(out, x, z, xSize, zSize, xScale, zScale, lacunarity, 0.5);
     }
 
-    // Gets the maximum value for a given value of amplitudeScale. For those values, the range is from -getMaximumValue to getMaximumValue.
-    public double getMaximumValue(double amplitudeScale)
-    {
-        double max = 0.0;
-
-        double amplitude = 1.0;
-        for (int l = 0; l < numOctaves; l++)
-        {
-            max += 0.55D / amplitude;
-            amplitude *= amplitudeScale;
-        }
-
-        return max;
-    }
+    public double @NotNull [] getRegion(double @Nullable [] out, final double x, final double z, final int xSize, final int zSize, double xScale, double zScale, final double lacunarity, final double persistence) {
+        xScale /= 1.5;
+        zScale /= 1.5;
 
-    public double[] getValue(double[] out, double x, double z, int xSize, int zSize, double xScale, double zScale, double frequencyScale)
-    {
-        return getValue(out, x, z, xSize, zSize, xScale, zScale, frequencyScale, 0.5D);
-    }
-
-    // Uses Fractal Brownian Motion to refine the noise.
-    public double[] getValue(double[] out, double x, double z, int xSize, int zSize, double xScale, double zScale, double frequencyScale, double amplitudeScale)
-    {
-        xScale /= 1.5D;
-        zScale /= 1.5D;
-
-        if (out == null || out.length < xSize * zSize)
-        {
+        if (out == null || out.length < xSize * zSize) {
             out = new double[xSize * zSize];
-        }
-        else
-        {
-            Arrays.fill(out, 0.0D);
+        } else {
+            Arrays.fill(out, 0.0);
         }
 
-        double frequency = 1.0D;
-        double amplitude = 1.0D;
-        for(int l = 0; l < numOctaves; l++)
-        {
-            octaves[l].add(out, x, z, xSize, zSize, xScale * frequency, zScale * frequency, 0.55D / amplitude);
-            frequency *= frequencyScale;
-            amplitude *= amplitudeScale;
+        double frequency = 1.0;
+        double amplitude = 1.0;
+        for (int l = 0; l < this.numOctaves; l++) {
+            this.octaves[l].add(out, x, z, xSize, zSize, xScale * frequency, zScale * frequency, 0.55D / amplitude);
+            frequency *= lacunarity;
+            amplitude *= persistence;
         }
 
         return out;
diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
index fd9bff937..ce482f915 100644
--- a/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/SimplexNoise.java
@@ -1,86 +1,86 @@
 package net.minecraft.core.world.noise;
 
+import org.jetbrains.annotations.NotNull;
+
 import java.util.Random;
 
-public class SimplexNoise
-{
-    private static final int[][] GRAD = {
-            {  1,  1,  0 }, { -1,  1,  0 }, {  1, -1,  0 },
-            { -1, -1,  0 }, {  1,  0,  1 }, { -1,  0,  1 },
-            {  1,  0, -1 }, { -1,  0, -1 }, {  0,  1,  1 },
-            {  0, -1,  1 }, {  0,  1, -1 }, {  0, -1, -1 }
+public class SimplexNoise {
+    private static final int @NotNull [] @NotNull [] GRAD = {
+        {  1,  1,  0 }, { -1,  1,  0 }, {  1, -1,  0 },
+        { -1, -1,  0 }, {  1,  0,  1 }, { -1,  0,  1 },
+        {  1,  0, -1 }, { -1,  0, -1 }, {  0,  1,  1 },
+        {  0, -1,  1 }, {  0,  1, -1 }, {  0, -1, -1 }
     };
     private static final double F2 = 0.5D * (Math.sqrt(3D) - 1.0D);
     private static final double G2 = (3D - Math.sqrt(3D)) / 6D;
-    private final int[] p;
+
+    private final int @NotNull [] p;
     public final double xo;
     public final double yo;
     public final double zo;
 
-    public SimplexNoise(Random random)
-    {
-        p = new int[512];
-        xo = random.nextDouble() * 256D;
-        yo = random.nextDouble() * 256D;
-        zo = random.nextDouble() * 256D;
+    public SimplexNoise(final @NotNull Random random) {
+        this.p = new int[512];
+        this.xo = random.nextDouble() * 256D;
+        this.yo = random.nextDouble() * 256D;
+        this.zo = random.nextDouble() * 256D;
 
-        for(int i = 0; i < 256; i++)
-        {
-            p[i] = i;
+        for (int i = 0; i < 256; i++) {
+            this.p[i] = i;
         }
 
-        for(int i = 0; i < 256; i++)
-        {
-            int k = random.nextInt(256 - i) + i;
-            int l = p[i];
-            p[i] = p[k];
-            p[k] = l;
-            p[i + 256] = p[i];
+        for (int i = 0; i < 256; i++) {
+            final int newI = random.nextInt(256 - i) + i;
+            final int temp = this.p[i];
+            this.p[i] = this.p[newI];
+            this.p[newI] = temp;
+            this.p[i + 256] = this.p[i];
         }
     }
 
-    private static int wrap(double d)
-    {
-        return d <= 0.0D ? (int)d - 1 : (int)d;
+    private static int fastFloor(final double d) {
+        return d <= 0.0D ? (int) d - 1 : (int) d;
     }
 
-    private static double dot(int[] vec, double x, double y)
-    {
-        return (double)vec[0] * x + (double)vec[1] * y;
+    private static double dot(final int @NotNull [] vec, final double x, final double y) {
+        return (double) vec[0] * x + (double) vec[1] * y;
     }
 
     // Values generated are guaranteed to be between -1.0 and 1.0, multiplied by amplitude.
-    public void add(double[] out, double xOffset, double zOffset, int xSize, int zSize, double xScale, double zScale, double amplitude)
-    {
+    public void add(
+        final double @NotNull [] out,
+        final double xOffset, final double zOffset,
+        final int xSize, final int zSize,
+        final double xScale, final double zScale,
+        final double amplitude
+    ) {
         int index = 0;
-        for(int dx = 0; dx < xSize; dx++)
-        {
-            double x = (xOffset + (double)dx) * xScale + xo;
-            for(int dz = 0; dz < zSize; dz++)
-            {
-                double z = (zOffset + (double)dz) * zScale + yo;
+        for (int dx = 0; dx < xSize; dx++) {
+            final double x = (xOffset + (double) dx) * xScale + this.xo;
+            for (int dz = 0; dz < zSize; dz++) {
+                final double z = (zOffset + (double) dz) * zScale + this.yo;
 
                 // Skew the input space to determine which simplex cell we're in
-                double s = (x + z) * F2;
-                int i = wrap(x + s);
-                int j = wrap(z + s);
+                final double s = (x + z) * F2;
+                final int i = fastFloor(x + s);
+                final int j = fastFloor(z + s);
 
                 // Unskew the cell origin back to (x, z) space
-                double t = (double)(i + j) * G2;
-                double X0 = (double)i - t;
-                double Z0 = (double)j - t;
-                double x0 = x - X0;
-                double z0 = z - Z0;
+                final double t = (double) (i + j) * G2;
+                final double X0 = (double) i - t;
+                final double Z0 = (double) j - t;
+                final double x0 = x - X0;
+                final double z0 = z - Z0;
 
                 // For the 2D case, the simplex shape is an equilateral triangle.
                 // Determine which simplex we are in.
-                int i1, j1; // Offsets for second (middle) corner of simplex in (i, j) coords
-                if(x0 > z0) // Lower triangle, XZ order: (0, 0) -> (1, 0) -> (1, 1)
+                final int i1;  // Offsets for second (middle) corner of simplex in (i, j) coords
+                final int j1;
+                if (x0 > z0) // Lower triangle, XZ order: (0, 0) -> (1, 0) -> (1, 1)
                 {
                     i1 = 1;
                     j1 = 0;
-                }
-                else // Upper triangle, ZX order: (0, 0) -> (0, 1) -> (1, 1)
+                } else // Upper triangle, ZX order: (0, 0) -> (0, 1) -> (1, 1)
                 {
                     i1 = 0;
                     j1 = 1;
@@ -90,58 +90,49 @@ public class SimplexNoise
                 // a step of (0, 1) in (i, j) means a step of (-c, 1 - c) in (x, z), where
                 // c = (3 - sqrt(3)) / 6
 
-                double x1 = (x0 - (double)i1) + G2; // Offsets for middle corner in (x, z) unskewed coords
-                double z1 = (z0 - (double)j1) + G2;
-                double x2 = (x0 - 1.0D) + 2D * G2;  // Offsets for last corner in (x, z) unskewed coords
-                double z2 = (z0 - 1.0D) + 2D * G2;
+                final double x1 = (x0 - (double) i1) + G2; // Offsets for middle corner in (x, z) unskewed coords
+                final double z1 = (z0 - (double) j1) + G2;
+                final double x2 = (x0 - 1.0D) + 2D * G2;  // Offsets for last corner in (x, z) unskewed coords
+                final double z2 = (z0 - 1.0D) + 2D * G2;
 
                 // Work out the hashed gradient indices of the three simplex corners
-                int ib = i & 0xff;
-                int jb = j & 0xff;
-                int gi0 = p[ib + p[jb]] % 12;
-                int gi1 = p[ib + i1 + p[jb + j1]] % 12;
-                int gi2 = p[ib + 1 + p[jb + 1]] % 12;
+                final int ib = i & 0xff;
+                final int jb = j & 0xff;
+                final int gi0 = this.p[ib + this.p[jb]] % 12;
+                final int gi1 = this.p[ib + i1 + this.p[jb + j1]] % 12;
+                final int gi2 = this.p[ib + 1 + this.p[jb + 1]] % 12;
 
                 // Calculate the contribution from the first corner
                 double t0 = 0.5D - x0 * x0 - z0 * z0;
-                double n0;
-                if(t0 < 0.0D)
-                {
+                final double n0;
+                if (t0 < 0.0D) {
                     n0 = 0.0D;
-                }
-                else
-                {
+                } else {
                     t0 *= t0;
                     n0 = t0 * t0 * dot(GRAD[gi0], x0, z0);
                 }
 
                 // Calculate the contribution from the second corner
                 double t1 = 0.5D - x1 * x1 - z1 * z1;
-                double n1;
-                if(t1 < 0.0D)
-                {
+                final double n1;
+                if (t1 < 0.0D) {
                     n1 = 0.0D;
-                }
-                else
-                {
+                } else {
                     t1 *= t1;
                     n1 = t1 * t1 * dot(GRAD[gi1], x1, z1);
                 }
 
                 // Calculate the contribution from the third corner
                 double t2 = 0.5D - x2 * x2 - z2 * z2;
-                double n2;
-                if(t2 < 0.0D)
-                {
+                final double n2;
+                if (t2 < 0.0D) {
                     n2 = 0.0D;
-                }
-                else
-                {
+                } else {
                     t2 *= t2;
                     n2 = t2 * t2 * dot(GRAD[gi2], x2, z2);
                 }
 
-                double value = 70 * (n0 + n1 + n2);
+                final double value = 70 * (n0 + n1 + n2);
                 out[index++] += value * amplitude;
             }
         }
